% load some generated sample data sets banana_mc, banana_bc, reg
% all of them with train/test split
load data;

%% Least Squares Regression is the default
model = lsSVM(reg_train_x, reg_train_y,'DISPLAY','1');
model.test(reg_test_x,reg_test_y);
model.predict(reg_test_x, '-d 0');

%% For classification specify the MutliClass-Solver (this will convert the Y-Variable
model = mcSVM(banana_mc_train_x, banana_mc_train_y,'DISPLAY','1','folds','3');
model.test(banana_mc_test_x, banana_mc_test_y);

%% Specify further parameters, e.g. 8-fold cross-validation
model = liquidSvmModel(banana_bc_train_x, banana_bc_train_y, 'SCENARIO','MC');
% if liquidSvmModel is used then train and select have to be issued,
% and by that they can be configured
model.train('-d 1 -T 2 -f 3 8');
model.select('-d 1');

model.test(banana_bc_test_x, banana_bc_test_y, '-d', '2', '-T', '-1');
model.test(banana_bc_test_x, banana_bc_test_y, '-d 2 -T -1');
model.test(banana_bc_test_x, banana_bc_test_y);
model.predict(banana_bc_test_x, '-d 1');

%% Quantile Regression
model = qtSVM(reg_train_x, reg_train_y,[.2,.5],'DISPLAY','1');
model.test(reg_test_x,reg_test_y);

%% Expectile Regression
model = exSVM(reg_train_x, reg_train_y,'DISPLAY','1');
model.test(reg_test_x,reg_test_y);

%% Receiver Operating Characteristic curve
model = rocSVM(banana_bc_train_x, banana_bc_train_y,6,'DISPLAY','1');
model.test(banana_bc_test_x,banana_bc_test_y);

%% Neyman-Pearson lemma
model = nplSVM(banana_bc_train_x, banana_bc_train_y, 1, 'DISPLAY','1');
model.test(banana_bc_test_x,banana_bc_test_y);
